#include "stdafx.h"
#include "testgetfolder.h"
#include "testgetfolderDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CTestgetfolderDlg::CTestgetfolderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestgetfolderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestgetfolderDlg)
	m_bOldStyle = FALSE;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  m_dwValidationFlags = 0;
  m_sFolder = _T("");
}

void CTestgetfolderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestgetfolderDlg)
	DDX_Check(pDX, IDC_OLD_STYLE, m_bOldStyle);
	//}}AFX_DATA_MAP
  
  DWORD dwFlags = 0;
  if (m_bOldStyle)
    dwFlags |= GFLDR_OLD_STYLE_DIALOG;

  DDX_FolderControl(pDX, IDC_FOLDER, m_ctrlGetFolder, dwFlags, "Please specify a folder");
  DDX_FolderValue(pDX, m_ctrlGetFolder, m_sFolder);
  DDV_FolderControl(pDX, m_ctrlGetFolder, m_dwValidationFlags);


  if (!pDX->m_bSaveAndValidate)
  {
    OnReadonly();
    OnRequirevalid();
  }
}

BEGIN_MESSAGE_MAP(CTestgetfolderDlg, CDialog)
	//{{AFX_MSG_MAP(CTestgetfolderDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OLD_STYLE, OnOldStyle)
	ON_BN_CLICKED(IDC_READONLY, OnReadonly)
	ON_BN_CLICKED(IDC_REQUIREVALID, OnRequirevalid)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CTestgetfolderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	
	return TRUE;
}

void CTestgetfolderDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CTestgetfolderDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestgetfolderDlg::OnOldStyle() 
{
  CDataExchange DX(this, TRUE);
  DDX_Check(&DX, IDC_OLD_STYLE, m_bOldStyle);

  DWORD dwFlags = m_ctrlGetFolder.GetFlags();
  if (m_bOldStyle)
    dwFlags |= GFLDR_OLD_STYLE_DIALOG;
  else
    dwFlags &= ~GFLDR_OLD_STYLE_DIALOG; 

  m_ctrlGetFolder.SetFlags(dwFlags);
}

void CTestgetfolderDlg::OnReadonly() 
{
  CDataExchange DX(this, TRUE);
  BOOL bReadOnly;
  DDX_Check(&DX, IDC_READONLY, bReadOnly);
  m_ctrlGetFolder.SetReadOnly(bReadOnly);
}

void CTestgetfolderDlg::OnRequirevalid() 
{
  BOOL bRequireValid;
  CDataExchange DX(this, TRUE);
	DDX_Check(&DX, IDC_REQUIREVALID, bRequireValid);

  DWORD dwFlags = m_ctrlGetFolder.GetFlags();
  if (bRequireValid)
    m_dwValidationFlags |= GFLDR_FOLDER_MUST_EXIST;
  else
    m_dwValidationFlags &= ~GFLDR_FOLDER_MUST_EXIST; 
}
